searchNodes=[{"type":"module","title":"Membrane.VideoCompositor","doc":"A bin responsible for doing framerate conversion on all input videos and piping them into the compositor element. Bin options Passed via struct Membrane.VideoCompositor.t/0 output_stream_format Membrane.RawVideo . t ( ) Required Stream format for the output video of the compositor handler Handler . t ( ) Required Module implementing callbacks reacting to VC events. Specifies how Membrane.VideoCompositor.Scene should look like. Describes what VC should compose. queuing_strategy QueueingStrategy . t ( ) Default value: Membrane.VideoCompositor.QueueingStrategy.Offline Specifies used frames queueing strategy metadata init_metadata ( ) Default value: nil User-specified init metadata passed to handler callbacks. Passing init metadata into Membrane.VideoCompositor.Handler.handle_init/1 callback allows the user to alternate custom-implemented init callback logic. Pads :input Accepted formats: % RawVideo { pixel_format : :I420 } Direction: :input Availability: :on_request Pad options: timestamp_offset Membrane.Time . non_neg ( ) Default value: 0 Input stream PTS offset in nanoseconds. Must be non-negative. metadata input_pad_metadata ( ) Default value: nil User-specified input stream metadata passed to handler callbacks. Passing pad metadata into Membrane.VideoCompositor.Handler.handle_inputs_change/3 callback, allows the user to alternate custom-implemented callbacks logic, e.g. prioritizing input stream in the Membrane.VideoCompositor.Scene structs returned from callback. :output Accepted formats: % RawVideo { pixel_format : :I420 } Direction: :output Availability: :always","ref":"Membrane.VideoCompositor.html"},{"type":"function","title":"Membrane.VideoCompositor.options/0","doc":"Returns description of options available for this module","ref":"Membrane.VideoCompositor.html#options/0"},{"type":"type","title":"Membrane.VideoCompositor.init_metadata/0","doc":"User-specified init metadata passed to handler callbacks. Passing init metadata into Membrane.VideoCompositor.Handler.handle_init/1 callback allows the user to alternate custom-implemented init callback logic.","ref":"Membrane.VideoCompositor.html#t:init_metadata/0"},{"type":"type","title":"Membrane.VideoCompositor.init_options/0","doc":"","ref":"Membrane.VideoCompositor.html#t:init_options/0"},{"type":"type","title":"Membrane.VideoCompositor.input_pad_metadata/0","doc":"User-specified input stream metadata passed to handler callbacks. Passing pad metadata into Membrane.VideoCompositor.Handler.handle_inputs_change/3 callback, allows the user to alternate custom-implemented callbacks logic, e.g. prioritizing input stream in the Membrane.VideoCompositor.Scene structs returned from callback.","ref":"Membrane.VideoCompositor.html#t:input_pad_metadata/0"},{"type":"type","title":"Membrane.VideoCompositor.input_pad_options/0","doc":"","ref":"Membrane.VideoCompositor.html#t:input_pad_options/0"},{"type":"type","title":"Membrane.VideoCompositor.input_pad_opts/0","doc":"Options for pad :input","ref":"Membrane.VideoCompositor.html#t:input_pad_opts/0"},{"type":"type","title":"Membrane.VideoCompositor.t/0","doc":"Struct containing options for Membrane.VideoCompositor","ref":"Membrane.VideoCompositor.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.BaseVideoPlacement","doc":"A struct describing the video position, size and z-value for use with the rust-based compositor on the output frame, before video transformations. Values position: tuple given in pixels, relative to the top right corner of the output frame, represents the position on the output frame before transformations size: tuple given in pixels, represents video resolution on the output frame before transformations z_value: float in [0.0, 1.0] range, specifies priority: videos with higher z_value s are 'in front' of videos with lower z_value s Examples If you want to place the video in the bottom left quarter of the 4k output frame, above videos on 0.0 z_value level: iex&gt; alias Membrane.VideoCompositor.BaseVideoPlacement Membrane.VideoCompositor.BaseVideoPlacement iex&gt; % BaseVideoPlacement { position : { 1920 , 1080 } , size : { 1920 , 1080 } , z_value : 0.5 } % Membrane.VideoCompositor.BaseVideoPlacement { position : { 1920 , 1080 } , size : { 1920 , 1080 } , z_value : 0.5 }","ref":"Membrane.VideoCompositor.BaseVideoPlacement.html"},{"type":"type","title":"Membrane.VideoCompositor.BaseVideoPlacement.t/0","doc":"","ref":"Membrane.VideoCompositor.BaseVideoPlacement.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.Scene","doc":"Structure representing a top level specification of what is Video Compositor supposed to render.","ref":"Membrane.VideoCompositor.Scene.html"},{"type":"function","title":"Membrane.VideoCompositor.Scene.empty/0","doc":"","ref":"Membrane.VideoCompositor.Scene.html#empty/0"},{"type":"function","title":"Membrane.VideoCompositor.Scene.pads/1","doc":"","ref":"Membrane.VideoCompositor.Scene.html#pads/1"},{"type":"function","title":"Membrane.VideoCompositor.Scene.validate/3","doc":"","ref":"Membrane.VideoCompositor.Scene.html#validate/3"},{"type":"type","title":"Membrane.VideoCompositor.Scene.t/0","doc":"Specify how output frame should look like. If input pad isn't specified in video_configs it won't be used in composition.","ref":"Membrane.VideoCompositor.Scene.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.VideoConfig","doc":"Structure representing a specification of how Video Compositor should transform single input video.","ref":"Membrane.VideoCompositor.VideoConfig.html"},{"type":"type","title":"Membrane.VideoCompositor.VideoConfig.t/0","doc":"Describe video base placement and transformations. For more information view Elixir.Membrane.VideoCompositor.BaseVideoPlacement and Elixir.Membrane.VideoCompositor.Transformations .","ref":"Membrane.VideoCompositor.VideoConfig.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.Transformations","doc":"Describes all transformations applied to video. Transformations can change resolution of frame. Applying transformations may change size of video on the output frame (e.x. adding border to video will make video larger). As a contributor adding a new type of transformation, you must create new struct module type and add it to this type definition.","ref":"Membrane.VideoCompositor.Transformations.html"},{"type":"type","title":"Membrane.VideoCompositor.Transformations.t/0","doc":"","ref":"Membrane.VideoCompositor.Transformations.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.Transformations.CornersRounding","doc":"Describe corners rounding transformation parameter. Corner rounding transformation can be imagined as placing four circles with specified radius adjoining to frame borders, placed inside frame and making space between circle edge and nearest frame corner transparent. Values border_radius: non negative integer representing radius of circle &quot;cutting&quot; frame corner part. Examples Example struct describing transformation which rounds corners with 100 pixel radius: iex&gt; alias Membrane.VideoCompositor.Transformations.CornersRounding Membrane.VideoCompositor.Transformations.CornersRounding iex&gt; % CornersRounding { border_radius : 100 } % Membrane.VideoCompositor.Transformations.CornersRounding { border_radius : 100 }","ref":"Membrane.VideoCompositor.Transformations.CornersRounding.html"},{"type":"type","title":"Membrane.VideoCompositor.Transformations.CornersRounding.t/0","doc":"Describe cropping transformation parameter.","ref":"Membrane.VideoCompositor.Transformations.CornersRounding.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.Transformations.Cropping","doc":"Describe cropping transformation parameters. Values crop_top_left_corner: tuple representing coords (in [0, 1] range) of top left corner of the visible part of video crop_size: tuple representing width and height (in [0, 1] range) of the visible part of video cropped_video_position: optional atom, describe whether cropped video part should remain in cropped part or should be in position of video before transformation. For more reference see Examples section below. Examples Struct describing transformation, which displays only bottom right quarter of input video, with cropped part remaining in its position: iex&gt; alias Membrane.VideoCompositor.Transformations.Cropping Membrane.VideoCompositor.Transformations.Cropping iex&gt; % Cropping { crop_top_left_corner : { 0.5 , 0.5 } , crop_size : { 0.5 , 0.5 } , cropped_video_position : :crop_part_position # can be omitted, this is default value } % Membrane.VideoCompositor.Transformations.Cropping { crop_top_left_corner : { 0.5 , 0.5 } , crop_size : { 0.5 , 0.5 } , cropped_video_position : :crop_part_position } Struct describing transformation, which displays only right part of input video in left part of input video: iex&gt; alias Membrane.VideoCompositor.Transformations.Cropping Membrane.VideoCompositor.Transformations.Cropping iex&gt; % Cropping { crop_top_left_corner : { 0.5 , 0.0 } , crop_size : { 0.5 , 1.0 } , cropped_video_position : :input_position } % Membrane.VideoCompositor.Transformations.Cropping { crop_top_left_corner : { 0.5 , 0.0 } , crop_size : { 0.5 , 1.0 } , cropped_video_position : :input_position }","ref":"Membrane.VideoCompositor.Transformations.Cropping.html"},{"type":"type","title":"Membrane.VideoCompositor.Transformations.Cropping.t/0","doc":"Describe cropping transformation parameters.","ref":"Membrane.VideoCompositor.Transformations.Cropping.html#t:t/0"},{"type":"behaviour","title":"Membrane.VideoCompositor.Handler","doc":"Module defining behaviour of handlers. Implementing handler allows to provide custom implementation and react to various events, among others by setting a new scene and the inner custom state.","ref":"Membrane.VideoCompositor.Handler.html"},{"type":"callback","title":"Membrane.VideoCompositor.Handler.handle_info/3","doc":"Callback invoked when video compositor receives a message that is not recognized as an internal membrane message. This callback allows one to communicate with a Video Compositor by sending custom messages and reacting to them.","ref":"Membrane.VideoCompositor.Handler.html#c:handle_info/3"},{"type":"callback","title":"Membrane.VideoCompositor.Handler.handle_init/1","doc":"Callback invoked upon initialization of Video Compositor.","ref":"Membrane.VideoCompositor.Handler.html#c:handle_init/1"},{"type":"callback","title":"Membrane.VideoCompositor.Handler.handle_inputs_change/3","doc":"Callback invoked upon change of VC t:inputs() . inputs changing input videos: video added video removed video stream format change","ref":"Membrane.VideoCompositor.Handler.html#c:handle_inputs_change/3"},{"type":"type","title":"Membrane.VideoCompositor.Handler.context/0","doc":"Contains state of VC before handling event invoking callback.","ref":"Membrane.VideoCompositor.Handler.html#t:context/0"},{"type":"type","title":"Membrane.VideoCompositor.Handler.immediate_callback_return/0","doc":"Type of a valid return value from the callback. By returning this type, the scene will be changed immediate, i.e. at the moment when the event happens.","ref":"Membrane.VideoCompositor.Handler.html#t:immediate_callback_return/0"},{"type":"type","title":"Membrane.VideoCompositor.Handler.inputs/0","doc":"Describe all VC input videos used in composition.","ref":"Membrane.VideoCompositor.Handler.html#t:inputs/0"},{"type":"type","title":"Membrane.VideoCompositor.Handler.state/0","doc":"Type of user-managed inner state of the handler.","ref":"Membrane.VideoCompositor.Handler.html#t:state/0"},{"type":"type","title":"Membrane.VideoCompositor.Handler.t/0","doc":"Module implementing Membrane.VideoCompositor.Handler behaviour.","ref":"Membrane.VideoCompositor.Handler.html#t:t/0"},{"type":"type","title":"Membrane.VideoCompositor.Handler.timed_callback_return/0","doc":"Type of a valid return value from callback allowing to pick start time of a new scene.","ref":"Membrane.VideoCompositor.Handler.html#t:timed_callback_return/0"},{"type":"module","title":"Membrane.VideoCompositor.Handler.InputProperties","doc":"Defines properties of VC input video passed to callbacks.","ref":"Membrane.VideoCompositor.Handler.InputProperties.html"},{"type":"type","title":"Membrane.VideoCompositor.Handler.InputProperties.t/0","doc":"","ref":"Membrane.VideoCompositor.Handler.InputProperties.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.QueueingStrategy","doc":"Defines possible VideoCompositor frames and events queueing strategies.","ref":"Membrane.VideoCompositor.QueueingStrategy.html"},{"type":"type","title":"Membrane.VideoCompositor.QueueingStrategy.t/0","doc":"Defines possible queueing strategies. For specific strategy description, view: Membrane.VideoCompositor.QueueingStrategy.Live Membrane.VideoCompositor.QueueingStrategy.Offline","ref":"Membrane.VideoCompositor.QueueingStrategy.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.QueueingStrategy.Live","doc":"Live queueing strategy, suitable for real-time processing, like live streams. Every 1 / output fps seconds after start of composition (view latency/0 ) composes frames from every input stream with the smallest pts difference to output frame pts.","ref":"Membrane.VideoCompositor.QueueingStrategy.Live.html"},{"type":"type","title":"Membrane.VideoCompositor.QueueingStrategy.Live.eos_strategy/0","doc":"Specifies possible strategies for VideoCompositor to send Membrane.Element.Action.end_of_stream/0 . Strategies: In the :all_inputs_eos strategy VideoCompositor sends EOS after receiving EOSs from all input pads. In the :schedule_eos strategy VideoCompositor sends EOS after receiving schedule_eos_message/0 and EOSs from all input pads. If all input pads sent EOS and VideoCompositor hasn't received the schedule_eos_message/0 message, VC will produce frames black frames until it receives the schedule_eos_message/0 message. This is useful, when e.g. some peer connects to a VideoCompositor via the live streaming application. His connection can be dropped and restored multiple times. With this strategy, user can control when VC should send EOS.","ref":"Membrane.VideoCompositor.QueueingStrategy.Live.html#t:eos_strategy/0"},{"type":"type","title":"Membrane.VideoCompositor.QueueingStrategy.Live.latency/0","doc":"Latency specifies when VideoCompositor will start producing frames. Latency can be set to: Membrane.Time.non_neg/0 - a fixed time, after which VC will start composing frames, Setting latency to a higher value allows VideoCompositor to await longer for input frames, but results in higher output stream latency and RAM usage. :wait_for_start_event value, which awaits for t:start_composing_message/0 to trigger / schedule composing. Be aware that VC enqueues all received frames, so not sending t:start_composing_message/0 / sending it late, will result in high RAM usage. It doesn't modify output frames pts.","ref":"Membrane.VideoCompositor.QueueingStrategy.Live.html#t:latency/0"},{"type":"type","title":"Membrane.VideoCompositor.QueueingStrategy.Live.schedule_eos_message/0","doc":"Specifies how message scheduling EOS should look like. For more information on scheduling EOS see: eos_strategy/0 .","ref":"Membrane.VideoCompositor.QueueingStrategy.Live.html#t:schedule_eos_message/0"},{"type":"type","title":"Membrane.VideoCompositor.QueueingStrategy.Live.start_timer_message/0","doc":"Specifies the message that triggers/schedule the start of VC composing. Values: After receiving :start_composing message, VC will immediately start composing. After receiving {:start_composing, delay :: Membrane.Time.non_neg()} , VC will start composing after the time specified by delay","ref":"Membrane.VideoCompositor.QueueingStrategy.Live.html#t:start_timer_message/0"},{"type":"type","title":"Membrane.VideoCompositor.QueueingStrategy.Live.t/0","doc":"Describes parameters of live queueing strategy. For more information, view: latency/0","ref":"Membrane.VideoCompositor.QueueingStrategy.Live.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.QueueingStrategy.Offline","doc":"Offline queueing strategy, suitable for non-real-time processing. In this strategy frames are sent to the compositor only when all added input pads queues, with timestamp offset lower or equal to composed buffer pts, have at least one frame.","ref":"Membrane.VideoCompositor.QueueingStrategy.Offline.html"},{"type":"type","title":"Membrane.VideoCompositor.QueueingStrategy.Offline.t/0","doc":"","ref":"Membrane.VideoCompositor.QueueingStrategy.Offline.html#t:t/0"},{"type":"extras","title":"Membrane Video Compositor Plugin","doc":"Membrane plugin that accepts multiple video inputs, transforms them according to provided transformations and composes them into a single output video. It is part of Membrane Multimedia Framework .","ref":"readme.html"},{"type":"extras","title":"Membrane Video Compositor Plugin - Installation","doc":"The package can be installed by adding membrane_video_compositor_plugin to your list of dependencies in mix.exs : def deps do [ { :membrane_video_compositor_plugin , &quot;~&gt; 0.5.3&quot; } ] end Since parts of this package are implemented in Rust, you need to have a Rust installation to compile this package. You can get one here","ref":"readme.html#installation"},{"type":"extras","title":"Membrane Video Compositor Plugin - Usage","doc":"Before jumping into Livebook, check out this installation guide . Note that it's running on the previous version of this plugin.","ref":"readme.html#usage"},{"type":"extras","title":"Membrane Video Compositor Plugin - Copyright and License","doc":"Copyright 2022, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2022 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]